/*
  led.h
  Matlib 2010-02-05
*/

#ifndef _LED_H
#define _LED_H 1


/* pthread attributes to create detached threads. Initialized in main */
#include <pthread.h>
pthread_attr_t thread_attr;


#include <stdint.h>
#include <semaphore.h>
#define PATTERN_MAX 16
struct DevData;
struct DevData
{
  struct DevData *next;
  struct DevData *snext;
  sem_t slock;
  char *name;

  int fd;
  int arg;
  
  uint8_t fill [PATTERN_MAX];
  uint16_t delay [PATTERN_MAX];
  int pattern_length;
  int loop;
  int pattern_pos;
  
  pthread_t blink_tid;
  sem_t sem;
  void *(*active_blink) (void *);
  void (*led_set) (struct DevData *);
  void (*led_clr) (struct DevData *);
};

/* DevData -> flags:
     FLAG_BLINK  do 1 second blink when starting */
#define FLAG_BLINK 1

struct DevData *devdata_new (char *name, void (*led_set) (struct DevData *),
   void (*led_clr) (struct DevData *));



/* Error reporting, formatted (CHECK_ERROR) and simple (CHECK_ERRORS) */
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <errno.h>
#define CHECK_ERROR(__COND__,__FORMAT__,...) \
  if (__COND__) \
  { \
    fprintf (stderr, __FORMAT__ ": %s\n", __VA_ARGS__, strerror (errno)); \
    exit (EXIT_FAILURE); \
  }
#define CHECK_ERRORS(__COND__,__FUNC__) \
  if (__COND__) \
  { \
    perror (__FUNC__); \
    exit (EXIT_FAILURE); \
  }




#endif
