/*
  util.c
  Matlib  2010-02-07
*/


/* sig_ignore
   SIG_IGN seems to behave the same as blocked signal, at least on Linux. 
   We need to define our own handler then. */
void sig_ignore (int signum)
{
  signal (signum, sig_ignore);
}

/* sem_clean
   Semaphore cleanup wrapper for pthread_cleanup_push. */
void sem_clean (void *sem)
{
  sem_post ((sem_t *) sem);
}

/* block_signals
   Block SIGPIPE, currently. */
void block_signals (int daemon)
{
  sigset_t ss;
  sigemptyset (&ss);
  sigaddset (&ss, SIGPIPE);
  if (daemon != 0)
    sigaddset (&ss, SIGHUP);
  CHECK_ERRORS (sigprocmask (SIG_BLOCK, &ss, NULL) != 0, "sigprocmask");
}

